/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : TypeNameCollector.java                                   */
/* DESCRIPTION   : Collects the names of defined types                      */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.checker;

import java.util.*;

import fls.node.*;
import fls.analysis.*;
import fls.error.*;

public class TypeNameCollector extends DepthFirstAdapter {

    ErrorTable errorTable = new ErrorTable();
    HashSet<String> typeNames = new HashSet<String>();

    public ErrorTable getErrorTable() {
	return errorTable;
    }

    public HashSet<String> getTypeNames() {
	return typeNames;
    }

    public void outATypedef(ATypedef node) {
	String id = node.getId().getText();
	if (!typeNames.add(id)) {
	    errorTable.add(node.getId().getLine(),
			   new TypeRedefinedError(id));
	}
    }

}
