/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : EnvEntry.java                                            */
/* DESCRIPTION   : Environment entry                                        */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 4th January 2006                                         */
/****************************************************************************/

package fls.env;

import fls.types.*;

public class EnvEntry {

    Type type;
    boolean available;

    public EnvEntry(Type t) {
	type = t;
	available = true;
    }

    public EnvEntry(Type t, boolean a) {
	type = t;
	available = a;
    }

    public Type getType() {
	return type;
    }

    public boolean available() {
	return available;
    }

    public void makeUnavailable() {
	available = false;
    }

}
