/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : ErrorTable.java                                          */
/* DESCRIPTION   : Table of error reports                                   */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.error;

import java.util.*;
import java.io.*;

public class ErrorTable {

    private Vector<ErrorTableEntry> errors;

    public ErrorTable() {
	errors = new Vector<ErrorTableEntry>();
    }

    // Adds a new error.

    public void add(int line, Error e) {
	errors.addElement(new ErrorTableEntry(line,e));
    }

    public boolean hasErrors() {
	return !(errors.isEmpty());
    }

    public void output(PrintStream out, String header) {
	int numErrors = errors.size();
	out.print(numErrors);
	out.println(" errors were found " + header + ":");
	out.println();
	Enumeration<ErrorTableEntry> errs = errors.elements();
	while (errs.hasMoreElements()) {
	    errs.nextElement().output(out);
	    out.println();
	}
    }

}
