/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : ErrorTableEntry.java                                     */
/* DESCRIPTION   : Entry in a table of error reports                        */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.error;

import java.io.*;

public class ErrorTableEntry {

    private int line;
    private Error err;

    public ErrorTableEntry(int l, Error e) {
	line = l;
	err = e;
    }

    public void output(PrintStream out) {
	out.print("Line ");
	out.print(line);
	out.print(": Error: ");
	out.println(err.message());
    }

}
