/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : SelectWrongLabelError.java                               */
/* DESCRIPTION   : Error: select with non-existent label                    */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 4th January 2006                                         */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 4th January 2006                                         */
/****************************************************************************/

package fls.error;

public class SelectWrongLabelError extends Error {

    public String lab;
    public String ty;

    public SelectWrongLabelError(String l, String t) {
	lab = l;
	ty = t;
    }

    public String message() {
	return "attempt to select label \"" + lab + ", which does not exist in type \"" + ty + "\"";
    } 

}
