/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : SendMismatchError.java                                   */
/* DESCRIPTION   : Error: sending wrong type of data                        */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.error;

public class SendMismatchError extends Error {

    public String data;
    public String chan;

    public SendMismatchError(String d, String c) {
	data = d;
	chan = c;
    }

    public String message() {
	return "attempt to send data of type \"" + data + "\" on a channel whose type is \"" + chan + "\"";
    } 

}
