/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : WrongArgTypeError.java                                   */
/* DESCRIPTION   : Error: wrong type of argument to function                */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.error;

public class WrongArgTypeError extends Error {

    public String formal;
    public String actual;

    public WrongArgTypeError(String f, String a) {
	formal = f;
	actual = a;
    }

    public String message() {
	return "function expects argument type " + formal +
	    " but type " + actual +
	    " has been supplied";
    } 

}
