/* This file was generated by SableCC (http://www.sablecc.org/). */

package fls.lexer;

import java.io.*;
import java.util.*;
import fls.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TInt(text, line, pos); }
    Token new3(int line, int pos) { return new TIf(line, pos); }
    Token new4(int line, int pos) { return new TThen(line, pos); }
    Token new5(int line, int pos) { return new TElse(line, pos); }
    Token new6(int line, int pos) { return new TTrue(line, pos); }
    Token new7(int line, int pos) { return new TFalse(line, pos); }
    Token new8(int line, int pos) { return new TFn(line, pos); }
    Token new9(int line, int pos) { return new TLfn(line, pos); }
    Token new10(int line, int pos) { return new TArrow(line, pos); }
    Token new11(int line, int pos) { return new TTilde(line, pos); }
    Token new12(int line, int pos) { return new TFun(line, pos); }
    Token new13(int line, int pos) { return new TVal(line, pos); }
    Token new14(int line, int pos) { return new TLet(line, pos); }
    Token new15(int line, int pos) { return new TIn(line, pos); }
    Token new16(int line, int pos) { return new TIntTy(line, pos); }
    Token new17(int line, int pos) { return new TBoolTy(line, pos); }
    Token new18(int line, int pos) { return new TUnitTy(line, pos); }
    Token new19(int line, int pos) { return new TEndTy(line, pos); }
    Token new20(int line, int pos) { return new TBang(line, pos); }
    Token new21(int line, int pos) { return new TQuery(line, pos); }
    Token new22(int line, int pos) { return new TDot(line, pos); }
    Token new23(int line, int pos) { return new TFunArrow(line, pos); }
    Token new24(int line, int pos) { return new TLinFunArrow(line, pos); }
    Token new25(int line, int pos) { return new TTensor(line, pos); }
    Token new26(int line, int pos) { return new TClose(line, pos); }
    Token new27(int line, int pos) { return new TSend(line, pos); }
    Token new28(int line, int pos) { return new TReceive(line, pos); }
    Token new29(int line, int pos) { return new TLparen(line, pos); }
    Token new30(int line, int pos) { return new TRparen(line, pos); }
    Token new31(int line, int pos) { return new TComma(line, pos); }
    Token new32(int line, int pos) { return new TColon(line, pos); }
    Token new33(int line, int pos) { return new TSemi(line, pos); }
    Token new34(int line, int pos) { return new TEquals(line, pos); }
    Token new35(int line, int pos) { return new TLbracket(line, pos); }
    Token new36(int line, int pos) { return new TRbracket(line, pos); }
    Token new37(int line, int pos) { return new TFork(line, pos); }
    Token new38(int line, int pos) { return new TAccept(line, pos); }
    Token new39(int line, int pos) { return new TRequest(line, pos); }
    Token new40(int line, int pos) { return new TSelect(line, pos); }
    Token new41(int line, int pos) { return new TCase(line, pos); }
    Token new42(int line, int pos) { return new TOf(line, pos); }
    Token new43(int line, int pos) { return new TBar(line, pos); }
    Token new44(int line, int pos) { return new TAmp(line, pos); }
    Token new45(int line, int pos) { return new TPlus(line, pos); }
    Token new46(int line, int pos) { return new TLcurly(line, pos); }
    Token new47(int line, int pos) { return new TRcurly(line, pos); }
    Token new48(int line, int pos) { return new TLangle(line, pos); }
    Token new49(int line, int pos) { return new TRangle(line, pos); }
    Token new50(int line, int pos) { return new TTypes(line, pos); }
    Token new51(int line, int pos) { return new TEnv(line, pos); }
    Token new52(int line, int pos) { return new TBody(line, pos); }
    Token new53(String text, int line, int pos) { return new TId(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {35, 35, 6}, {38, 38, 7}, {40, 40, 8}, {41, 41, 9}, {43, 43, 10}, {44, 44, 11}, {45, 45, 12}, {46, 46, 13}, {47, 47, 14}, {48, 57, 15}, {58, 58, 16}, {59, 59, 17}, {60, 60, 18}, {61, 61, 19}, {62, 62, 20}, {63, 63, 21}, {65, 90, 22}, {91, 91, 23}, {93, 93, 24}, {97, 97, 25}, {98, 98, 26}, {99, 99, 27}, {100, 100, 22}, {101, 101, 28}, {102, 102, 29}, {103, 104, 22}, {105, 105, 30}, {106, 107, 22}, {108, 108, 31}, {109, 110, 22}, {111, 111, 32}, {112, 113, 22}, {114, 114, 33}, {115, 115, 34}, {116, 116, 35}, {117, 117, 36}, {118, 118, 37}, {119, 122, 22}, {123, 123, 38}, {124, 124, 39}, {125, 125, 40}, {126, 126, 41}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 42}, {111, 111, 43}, },
            {},
            {{47, 47, 44}, },
            {{48, 57, 45}, },
            {},
            {},
            {},
            {{62, 62, 46}, },
            {},
            {},
            {{65, 90, 47}, {97, 122, 47}, },
            {},
            {},
            {{65, 90, 47}, {97, 98, 47}, {99, 99, 48}, {100, 122, 47}, },
            {{65, 90, 47}, {97, 110, 47}, {111, 111, 49}, {112, 122, 47}, },
            {{65, 90, 47}, {97, 97, 50}, {98, 107, 47}, {108, 108, 51}, {109, 122, 47}, },
            {{65, 90, 47}, {97, 107, 47}, {108, 108, 52}, {109, 109, 47}, {110, 110, 53}, {111, 122, 47}, },
            {{65, 90, 47}, {97, 97, 54}, {98, 109, 47}, {110, 110, 55}, {111, 111, 56}, {112, 116, 47}, {117, 117, 57}, {118, 122, 47}, },
            {{65, 90, 47}, {97, 101, 47}, {102, 102, 58}, {103, 109, 47}, {110, 110, 59}, {111, 122, 47}, },
            {{65, 90, 47}, {97, 100, 47}, {101, 101, 60}, {102, 102, 61}, {103, 122, 47}, },
            {{65, 101, -32}, {102, 102, 62}, {103, 122, 47}, },
            {{65, 100, -33}, {101, 101, 63}, {102, 122, 47}, },
            {{65, 100, -33}, {101, 101, 64}, {102, 122, 47}, },
            {{65, 90, 47}, {97, 103, 47}, {104, 104, 65}, {105, 113, 47}, {114, 114, 66}, {115, 120, 47}, {121, 121, 67}, {122, 122, 47}, },
            {{65, 90, 47}, {97, 109, 47}, {110, 110, 68}, {111, 122, 47}, },
            {{65, 90, 47}, {97, 97, 69}, {98, 122, 47}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{9, 9, 70}, {10, 10, 71}, {13, 13, 72}, {32, 127, 70}, },
            {{48, 57, 45}, },
            {},
            {{65, 122, -24}, },
            {{65, 98, -27}, {99, 99, 73}, {100, 122, 47}, },
            {{65, 90, 47}, {97, 99, 47}, {100, 100, 74}, {101, 110, 47}, {111, 111, 75}, {112, 122, 47}, },
            {{65, 90, 47}, {97, 114, 47}, {115, 115, 76}, {116, 122, 47}, },
            {{65, 110, -28}, {111, 111, 77}, {112, 122, 47}, },
            {{65, 114, -52}, {115, 115, 78}, {116, 122, 47}, },
            {{65, 99, -51}, {100, 100, 79}, {101, 117, 47}, {118, 118, 80}, {119, 122, 47}, },
            {{65, 107, -30}, {108, 108, 81}, {109, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 90, 47}, {97, 113, 47}, {114, 114, 82}, {115, 122, 47}, },
            {{65, 109, -38}, {110, 110, 83}, {111, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 90, 47}, {97, 115, 47}, {116, 116, 84}, {117, 122, 47}, },
            {{65, 115, -61}, {116, 116, 85}, {117, 122, 47}, },
            {{65, 109, -38}, {110, 110, 86}, {111, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 98, -27}, {99, 99, 87}, {100, 112, 47}, {113, 113, 88}, {114, 122, 47}, },
            {{65, 107, -30}, {108, 108, 89}, {109, 109, 47}, {110, 110, 90}, {111, 122, 47}, },
            {{65, 100, -33}, {101, 101, 91}, {102, 122, 47}, },
            {{65, 90, 47}, {97, 116, 47}, {117, 117, 92}, {118, 122, 47}, },
            {{65, 90, 47}, {97, 111, 47}, {112, 112, 93}, {113, 122, 47}, },
            {{65, 90, 47}, {97, 104, 47}, {105, 105, 94}, {106, 122, 47}, },
            {{65, 107, -30}, {108, 108, 95}, {109, 122, 47}, },
            {{9, 127, -46}, },
            {},
            {},
            {{65, 100, -33}, {101, 101, 96}, {102, 122, 47}, },
            {{65, 90, 47}, {97, 120, 47}, {121, 121, 97}, {122, 122, 47}, },
            {{65, 107, -30}, {108, 108, 98}, {109, 122, 47}, },
            {{65, 100, -33}, {101, 101, 99}, {102, 122, 47}, },
            {{65, 114, -52}, {115, 115, 100}, {116, 122, 47}, },
            {{65, 100, -33}, {101, 101, 101}, {102, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 104, -70}, {105, 105, 102}, {106, 122, 47}, },
            {{65, 114, -52}, {115, 115, 103}, {116, 122, 47}, },
            {{65, 90, 47}, {97, 106, 47}, {107, 107, 104}, {108, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 100, -33}, {101, 101, 105}, {102, 122, 47}, },
            {{65, 116, -68}, {117, 117, 106}, {118, 122, 47}, },
            {{65, 100, -33}, {101, 101, 107}, {102, 122, 47}, },
            {{65, 99, -51}, {100, 100, 108}, {101, 122, 47}, },
            {{65, 109, -38}, {110, 110, 109}, {111, 122, 47}, },
            {{65, 100, -33}, {101, 101, 110}, {102, 122, 47}, },
            {{65, 100, -33}, {101, 101, 111}, {102, 122, 47}, },
            {{65, 115, -61}, {116, 116, 112}, {117, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 111, -69}, {112, 112, 113}, {113, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 100, -33}, {101, 101, 114}, {102, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 113, -58}, {114, 114, 115}, {115, 122, 47}, },
            {{65, 100, -33}, {101, 101, 116}, {102, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 104, -70}, {105, 105, 117}, {106, 122, 47}, },
            {{65, 100, -33}, {101, 101, 118}, {102, 122, 47}, },
            {{65, 98, -27}, {99, 99, 119}, {100, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 114, -52}, {115, 115, 120}, {116, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 115, -61}, {116, 116, 121}, {117, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 110, -28}, {111, 111, 122}, {112, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 90, 47}, {97, 117, 47}, {118, 118, 123}, {119, 122, 47}, },
            {{65, 114, -52}, {115, 115, 124}, {116, 122, 47}, },
            {{65, 115, -61}, {116, 116, 125}, {117, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 109, -38}, {110, 110, 126}, {111, 122, 47}, },
            {{65, 100, -33}, {101, 101, 127}, {102, 122, 47}, },
            {{65, 115, -61}, {116, 116, 128}, {117, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 90, 47}, {97, 108, 47}, {109, 109, 129}, {110, 122, 47}, },
            {{65, 122, -24}, },
            {{65, 122, -24}, },
            {{65, 100, -33}, {101, 101, 130}, {102, 122, 47}, },
            {{65, 109, -38}, {110, 110, 131}, {111, 122, 47}, },
            {{65, 115, -61}, {116, 116, 132}, {117, 122, 47}, },
            {{65, 122, -24}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {0, 0, 0, 0, 0, 20, 25, 44, 29, 30, 45, 31, -1, 22, -1, 2, 32, 33, 48, 34, 49, 21, 53, 35, 36, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 46, 43, 47, 11, 23, 24, -1, 2, 10, 53, 53, 53, 53, 53, 53, 53, 53, 8, 53, 53, 3, 15, 53, 53, 42, 53, 53, 53, 53, 53, 53, 53, -1, 1, 1, 53, 53, 53, 53, 53, 53, 19, 53, 53, 53, 12, 16, 14, 9, 53, 53, 53, 53, 53, 53, 53, 53, 13, 53, 52, 17, 41, 53, 5, 53, 53, 37, 53, 53, 53, 27, 4, 6, 53, 18, 53, 26, 53, 7, 53, 53, 53, 50, 38, 53, 53, 53, 40, 53, 28, 39, 53, 53, 53, 51, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
