/* This file was generated by SableCC (http://www.sablecc.org/). */

package fls.parser;

import fls.lexer.*;
import fls.node.*;
import fls.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(16), node, false); } break;
                    case 3: { Node node = new3(); push(goTo(16), node, false); } break;
                    case 4: { Node node = new4(); push(goTo(0), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(17), node, false); } break;
                    case 6: { Node node = new6(); push(goTo(17), node, false); } break;
                    case 7: { Node node = new7(); push(goTo(0), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(1), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(1), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(1), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(1), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(1), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(1), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(1), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(1), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(1), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(1), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(1), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(1), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(1), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(1), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(2), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(2), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(2), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(2), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(3), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(3), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(3), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(4), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(4), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(18), node, false); } break;
                    case 32: { Node node = new32(); push(goTo(18), node, false); } break;
                    case 33: { Node node = new33(); push(goTo(5), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(6), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(7), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(7), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(8), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(8), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(8), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(8), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(8), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(8), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(9), node, true); } break;
                    case 44: { Node node = new44(); push(goTo(9), node, true); } break;
                    case 45: { Node node = new45(); push(goTo(9), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(9), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(10), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(10), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(10), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(10), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(10), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(10), node, true); } break;
                    case 53: { Node node = new53(); push(goTo(10), node, true); } break;
                    case 54: { Node node = new54(); push(goTo(11), node, true); } break;
                    case 55: { Node node = new55(); push(goTo(12), node, true); } break;
                    case 56: { Node node = new56(); push(goTo(13), node, true); } break;
                    case 57: { Node node = new57(); push(goTo(13), node, true); } break;
                    case 58: { Node node = new58(); push(goTo(19), node, false); } break;
                    case 59: { Node node = new59(); push(goTo(19), node, false); } break;
                    case 60: { Node node = new60(); push(goTo(14), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(15), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PProgram node1 = (PProgram) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PExpression node6 = (PExpression) pop();
        TBody node5 = (TBody) pop();
        XPTypedId node4 = null;
        TEnv node3 = (TEnv) pop();
        XPTypedef node2 = null;
        TTypes node1 = (TTypes) pop();
        AProgram node = new AProgram(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new1()
    {
        PExpression node6 = (PExpression) pop();
        TBody node5 = (TBody) pop();
        XPTypedId node4 = null;
        TEnv node3 = (TEnv) pop();
        XPTypedef node2 = (XPTypedef) pop();
        TTypes node1 = (TTypes) pop();
        AProgram node = new AProgram(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new2()
    {
        PTypedef node2 = (PTypedef) pop();
        XPTypedef node1 = (XPTypedef) pop();
        X1PTypedef node = new X1PTypedef(node1, node2);
        return node;
    }

    Node new3()
    {
        PTypedef node1 = (PTypedef) pop();
        X2PTypedef node = new X2PTypedef(node1);
        return node;
    }

    Node new4()
    {
        PExpression node6 = (PExpression) pop();
        TBody node5 = (TBody) pop();
        XPTypedId node4 = (XPTypedId) pop();
        TEnv node3 = (TEnv) pop();
        XPTypedef node2 = null;
        TTypes node1 = (TTypes) pop();
        AProgram node = new AProgram(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new5()
    {
        PTypedId node2 = (PTypedId) pop();
        XPTypedId node1 = (XPTypedId) pop();
        X1PTypedId node = new X1PTypedId(node1, node2);
        return node;
    }

    Node new6()
    {
        PTypedId node1 = (PTypedId) pop();
        X2PTypedId node = new X2PTypedId(node1);
        return node;
    }

    Node new7()
    {
        PExpression node6 = (PExpression) pop();
        TBody node5 = (TBody) pop();
        XPTypedId node4 = (XPTypedId) pop();
        TEnv node3 = (TEnv) pop();
        XPTypedef node2 = (XPTypedef) pop();
        TTypes node1 = (TTypes) pop();
        AProgram node = new AProgram(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new8()
    {
        PTerm node1 = (PTerm) pop();
        ATermExpression node = new ATermExpression(node1);
        return node;
    }

    Node new9()
    {
        PExpression node6 = (PExpression) pop();
        TElse node5 = (TElse) pop();
        PExpression node4 = (PExpression) pop();
        TThen node3 = (TThen) pop();
        PExpression node2 = (PExpression) pop();
        TIf node1 = (TIf) pop();
        ACondExpression node = new ACondExpression(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new10()
    {
        PExpression node4 = (PExpression) pop();
        TArrow node3 = (TArrow) pop();
        PTypedId node2 = (PTypedId) pop();
        TFn node1 = (TFn) pop();
        AFnExpression node = new AFnExpression(node1, node2, node3, node4);
        return node;
    }

    Node new11()
    {
        PExpression node4 = (PExpression) pop();
        TArrow node3 = (TArrow) pop();
        PTypedId node2 = (PTypedId) pop();
        TLfn node1 = (TLfn) pop();
        ALfnExpression node = new ALfnExpression(node1, node2, node3, node4);
        return node;
    }

    Node new12()
    {
        PTerm node2 = (PTerm) pop();
        PTerm node1 = (PTerm) pop();
        AAppExpression node = new AAppExpression(node1, node2);
        return node;
    }

    Node new13()
    {
        PTerm node3 = (PTerm) pop();
        PTerm node2 = (PTerm) pop();
        TFork node1 = (TFork) pop();
        AForkExpression node = new AForkExpression(node1, node2, node3);
        return node;
    }

    Node new14()
    {
        PTerm node2 = (PTerm) pop();
        TAccept node1 = (TAccept) pop();
        AAcceptExpression node = new AAcceptExpression(node1, node2);
        return node;
    }

    Node new15()
    {
        PTerm node2 = (PTerm) pop();
        TRequest node1 = (TRequest) pop();
        ARequestExpression node = new ARequestExpression(node1, node2);
        return node;
    }

    Node new16()
    {
        PTerm node3 = (PTerm) pop();
        PTerm node2 = (PTerm) pop();
        TSend node1 = (TSend) pop();
        ASendExpression node = new ASendExpression(node1, node2, node3);
        return node;
    }

    Node new17()
    {
        PTerm node2 = (PTerm) pop();
        TReceive node1 = (TReceive) pop();
        AReceiveExpression node = new AReceiveExpression(node1, node2);
        return node;
    }

    Node new18()
    {
        PTerm node3 = (PTerm) pop();
        TId node2 = (TId) pop();
        TSelect node1 = (TSelect) pop();
        ASelectExpression node = new ASelectExpression(node1, node2, node3);
        return node;
    }

    Node new19()
    {
        TRcurly node6 = (TRcurly) pop();
        PBranches node5 = (PBranches) pop();
        TLcurly node4 = (TLcurly) pop();
        TOf node3 = (TOf) pop();
        PTerm node2 = (PTerm) pop();
        TCase node1 = (TCase) pop();
        ACaseExpression node = new ACaseExpression(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new20()
    {
        PTerm node2 = (PTerm) pop();
        TClose node1 = (TClose) pop();
        ACloseExpression node = new ACloseExpression(node1, node2);
        return node;
    }

    Node new21()
    {
        PExpression node4 = (PExpression) pop();
        TIn node3 = (TIn) pop();
        PBinding node2 = (PBinding) pop();
        TLet node1 = (TLet) pop();
        ALetExpression node = new ALetExpression(node1, node2, node3, node4);
        return node;
    }

    Node new22()
    {
        TInt node1 = (TInt) pop();
        AIntLitTerm node = new AIntLitTerm(node1);
        return node;
    }

    Node new23()
    {
        PBool node1 = (PBool) pop();
        ABoolLitTerm node = new ABoolLitTerm(node1);
        return node;
    }

    Node new24()
    {
        TId node1 = (TId) pop();
        AIdTerm node = new AIdTerm(node1);
        return node;
    }

    Node new25()
    {
        TRparen node3 = (TRparen) pop();
        PExpression node2 = (PExpression) pop();
        TLparen node1 = (TLparen) pop();
        AExpTerm node = new AExpTerm(node1, node2, node3);
        return node;
    }

    Node new26()
    {
        PExpression node3 = (PExpression) pop();
        TEquals node2 = (TEquals) pop();
        TId node1 = (TId) pop();
        AValBinding node = new AValBinding(node1, node2, node3);
        return node;
    }

    Node new27()
    {
        PExpression node7 = (PExpression) pop();
        TEquals node6 = (TEquals) pop();
        TRparen node5 = (TRparen) pop();
        TId node4 = (TId) pop();
        TComma node3 = (TComma) pop();
        TId node2 = (TId) pop();
        TLparen node1 = (TLparen) pop();
        ASplitBinding node = new ASplitBinding(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new28()
    {
        PExpression node9 = (PExpression) pop();
        TEquals node8 = (TEquals) pop();
        PTy node7 = (PTy) pop();
        TColon node6 = (TColon) pop();
        TRparen node5 = (TRparen) pop();
        PTypedId node4 = (PTypedId) pop();
        TLparen node3 = (TLparen) pop();
        TId node2 = (TId) pop();
        TFun node1 = (TFun) pop();
        AFunBinding node = new AFunBinding(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new29()
    {
        XPBarBranch node2 = null;
        PBranch node1 = (PBranch) pop();
        ABranches node = new ABranches(node1, node2);
        return node;
    }

    Node new30()
    {
        XPBarBranch node2 = (XPBarBranch) pop();
        PBranch node1 = (PBranch) pop();
        ABranches node = new ABranches(node1, node2);
        return node;
    }

    Node new31()
    {
        PBarBranch node2 = (PBarBranch) pop();
        XPBarBranch node1 = (XPBarBranch) pop();
        X1PBarBranch node = new X1PBarBranch(node1, node2);
        return node;
    }

    Node new32()
    {
        PBarBranch node1 = (PBarBranch) pop();
        X2PBarBranch node = new X2PBarBranch(node1);
        return node;
    }

    Node new33()
    {
        PExpression node6 = (PExpression) pop();
        TArrow node5 = (TArrow) pop();
        TRparen node4 = (TRparen) pop();
        TId node3 = (TId) pop();
        TLparen node2 = (TLparen) pop();
        TId node1 = (TId) pop();
        ABranch node = new ABranch(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new34()
    {
        PBranch node2 = (PBranch) pop();
        TBar node1 = (TBar) pop();
        ABarBranch node = new ABarBranch(node1, node2);
        return node;
    }

    Node new35()
    {
        TTrue node1 = (TTrue) pop();
        ATrueBool node = new ATrueBool(node1);
        return node;
    }

    Node new36()
    {
        TFalse node1 = (TFalse) pop();
        AFalseBool node = new AFalseBool(node1);
        return node;
    }

    Node new37()
    {
        PBaseTy node1 = (PBaseTy) pop();
        ABaseTy node = new ABaseTy(node1);
        return node;
    }

    Node new38()
    {
        PSessionTy node1 = (PSessionTy) pop();
        ASessionTy node = new ASessionTy(node1);
        return node;
    }

    Node new39()
    {
        PBaseTy node3 = (PBaseTy) pop();
        TFunArrow node2 = (TFunArrow) pop();
        PBaseTy node1 = (PBaseTy) pop();
        AFunTy node = new AFunTy(node1, node2, node3);
        return node;
    }

    Node new40()
    {
        PBaseTy node3 = (PBaseTy) pop();
        TLinFunArrow node2 = (TLinFunArrow) pop();
        PBaseTy node1 = (PBaseTy) pop();
        ALfunTy node = new ALfunTy(node1, node2, node3);
        return node;
    }

    Node new41()
    {
        PBaseTy node3 = (PBaseTy) pop();
        TTensor node2 = (TTensor) pop();
        PBaseTy node1 = (PBaseTy) pop();
        ATensorTy node = new ATensorTy(node1, node2, node3);
        return node;
    }

    Node new42()
    {
        TRbracket node3 = (TRbracket) pop();
        PTy node2 = (PTy) pop();
        TLbracket node1 = (TLbracket) pop();
        APortTy node = new APortTy(node1, node2, node3);
        return node;
    }

    Node new43()
    {
        TIntTy node1 = (TIntTy) pop();
        AIntBaseTy node = new AIntBaseTy(node1);
        return node;
    }

    Node new44()
    {
        TBoolTy node1 = (TBoolTy) pop();
        ABoolBaseTy node = new ABoolBaseTy(node1);
        return node;
    }

    Node new45()
    {
        TUnitTy node1 = (TUnitTy) pop();
        AUnitBaseTy node = new AUnitBaseTy(node1);
        return node;
    }

    Node new46()
    {
        TRparen node3 = (TRparen) pop();
        PTy node2 = (PTy) pop();
        TLparen node1 = (TLparen) pop();
        ACompoundBaseTy node = new ACompoundBaseTy(node1, node2, node3);
        return node;
    }

    Node new47()
    {
        TId node1 = (TId) pop();
        ANamedSessionTy node = new ANamedSessionTy(node1);
        return node;
    }

    Node new48()
    {
        TId node2 = (TId) pop();
        TTilde node1 = (TTilde) pop();
        ADualSessionTy node = new ADualSessionTy(node1, node2);
        return node;
    }

    Node new49()
    {
        TEndTy node1 = (TEndTy) pop();
        AEndSessionTy node = new AEndSessionTy(node1);
        return node;
    }

    Node new50()
    {
        PSessionTy node4 = (PSessionTy) pop();
        TDot node3 = (TDot) pop();
        PBaseTy node2 = (PBaseTy) pop();
        TBang node1 = (TBang) pop();
        AOutputSessionTy node = new AOutputSessionTy(node1, node2, node3, node4);
        return node;
    }

    Node new51()
    {
        PSessionTy node4 = (PSessionTy) pop();
        TDot node3 = (TDot) pop();
        PBaseTy node2 = (PBaseTy) pop();
        TQuery node1 = (TQuery) pop();
        AInputSessionTy node = new AInputSessionTy(node1, node2, node3, node4);
        return node;
    }

    Node new52()
    {
        TRangle node4 = (TRangle) pop();
        PLabTys node3 = (PLabTys) pop();
        TLangle node2 = (TLangle) pop();
        TPlus node1 = (TPlus) pop();
        AChoiceSessionTy node = new AChoiceSessionTy(node1, node2, node3, node4);
        return node;
    }

    Node new53()
    {
        TRangle node4 = (TRangle) pop();
        PLabTys node3 = (PLabTys) pop();
        TLangle node2 = (TLangle) pop();
        TAmp node1 = (TAmp) pop();
        ABranchSessionTy node = new ABranchSessionTy(node1, node2, node3, node4);
        return node;
    }

    Node new54()
    {
        PTy node3 = (PTy) pop();
        TEquals node2 = (TEquals) pop();
        TId node1 = (TId) pop();
        ATypedef node = new ATypedef(node1, node2, node3);
        return node;
    }

    Node new55()
    {
        PTy node3 = (PTy) pop();
        TColon node2 = (TColon) pop();
        TId node1 = (TId) pop();
        ATypedId node = new ATypedId(node1, node2, node3);
        return node;
    }

    Node new56()
    {
        XPCommaLabTy node2 = null;
        PLabTy node1 = (PLabTy) pop();
        ALabTys node = new ALabTys(node1, node2);
        return node;
    }

    Node new57()
    {
        XPCommaLabTy node2 = (XPCommaLabTy) pop();
        PLabTy node1 = (PLabTy) pop();
        ALabTys node = new ALabTys(node1, node2);
        return node;
    }

    Node new58()
    {
        PCommaLabTy node2 = (PCommaLabTy) pop();
        XPCommaLabTy node1 = (XPCommaLabTy) pop();
        X1PCommaLabTy node = new X1PCommaLabTy(node1, node2);
        return node;
    }

    Node new59()
    {
        PCommaLabTy node1 = (PCommaLabTy) pop();
        X2PCommaLabTy node = new X2PCommaLabTy(node1);
        return node;
    }

    Node new60()
    {
        PLabTy node2 = (PLabTy) pop();
        TComma node1 = (TComma) pop();
        ACommaLabTy node = new ACommaLabTy(node1, node2);
        return node;
    }

    Node new61()
    {
        PSessionTy node3 = (PSessionTy) pop();
        TColon node2 = (TColon) pop();
        TId node1 = (TId) pop();
        ALabTy node = new ALabTy(node1, node2, node3);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {48, SHIFT, 1}, },
			{{-1, ERROR, 1}, {49, SHIFT, 3}, {51, SHIFT, 4}, },
			{{-1, ERROR, 2}, {52, ACCEPT, -1}, },
			{{-1, ERROR, 3}, {50, SHIFT, 7}, {51, SHIFT, 8}, },
			{{-1, ERROR, 4}, {32, SHIFT, 11}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 6}, {49, SHIFT, 12}, {51, SHIFT, 4}, },
			{{-1, ERROR, 7}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 8}, {30, SHIFT, 34}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 10}, {50, SHIFT, 35}, {51, SHIFT, 8}, },
			{{-1, ERROR, 11}, {9, SHIFT, 37}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {27, SHIFT, 44}, {33, SHIFT, 45}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, ERROR, 12}, {50, SHIFT, 52}, {51, SHIFT, 8}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 15}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 18}, {51, SHIFT, 8}, },
			{{-1, ERROR, 19}, {51, SHIFT, 8}, },
			{{-1, ERROR, 20}, {10, SHIFT, 57}, {27, SHIFT, 58}, {51, SHIFT, 59}, },
			{{-1, ERROR, 21}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 22}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 23}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 24}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 25}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 26}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 27}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 28}, {51, SHIFT, 68}, },
			{{-1, ERROR, 29}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 8}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 34}, {9, SHIFT, 37}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {27, SHIFT, 44}, {33, SHIFT, 45}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, ERROR, 35}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 37}, {51, SHIFT, 73}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 49}, },
			{{-1, ERROR, 42}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {27, SHIFT, 44}, },
			{{-1, ERROR, 43}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {27, SHIFT, 44}, },
			{{-1, ERROR, 44}, {9, SHIFT, 37}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {27, SHIFT, 44}, {33, SHIFT, 45}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, ERROR, 45}, {9, SHIFT, 37}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {27, SHIFT, 44}, {33, SHIFT, 45}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, ERROR, 46}, {46, SHIFT, 78}, },
			{{-1, ERROR, 47}, {46, SHIFT, 79}, },
			{{-1, REDUCE, 47}, },
			{{-1, REDUCE, 54}, },
			{{-1, REDUCE, 37}, {21, SHIFT, 80}, {22, SHIFT, 81}, {23, SHIFT, 82}, },
			{{-1, REDUCE, 38}, },
			{{-1, ERROR, 52}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 53}, {50, SHIFT, 84}, {51, SHIFT, 8}, },
			{{-1, ERROR, 54}, {2, SHIFT, 85}, },
			{{-1, ERROR, 55}, {8, SHIFT, 86}, },
			{{-1, ERROR, 56}, {8, SHIFT, 87}, },
			{{-1, ERROR, 57}, {51, SHIFT, 88}, },
			{{-1, ERROR, 58}, {51, SHIFT, 89}, },
			{{-1, ERROR, 59}, {32, SHIFT, 90}, },
			{{-1, ERROR, 60}, {13, SHIFT, 91}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 62}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 64}, {28, SHIFT, 93}, },
			{{-1, ERROR, 65}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 15}, },
			{{-1, ERROR, 68}, {0, SHIFT, 14}, {4, SHIFT, 16}, {5, SHIFT, 17}, {27, SHIFT, 24}, {51, SHIFT, 30}, },
			{{-1, ERROR, 69}, {40, SHIFT, 96}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 48}, },
			{{-1, ERROR, 74}, {20, SHIFT, 97}, },
			{{-1, ERROR, 75}, {20, SHIFT, 98}, },
			{{-1, ERROR, 76}, {28, SHIFT, 99}, },
			{{-1, ERROR, 77}, {34, SHIFT, 100}, },
			{{-1, ERROR, 78}, {51, SHIFT, 101}, },
			{{-1, ERROR, 79}, {51, SHIFT, 101}, },
			{{-1, ERROR, 80}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {27, SHIFT, 44}, },
			{{-1, ERROR, 81}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {27, SHIFT, 44}, },
			{{-1, ERROR, 82}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {27, SHIFT, 44}, },
			{{-1, REDUCE, 1}, },
			{{-1, ERROR, 84}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 85}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 86}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 87}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 88}, {27, SHIFT, 112}, },
			{{-1, ERROR, 89}, {29, SHIFT, 113}, },
			{{-1, ERROR, 90}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 91}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 96}, {44, SHIFT, 116}, },
			{{-1, ERROR, 97}, {9, SHIFT, 37}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, ERROR, 98}, {9, SHIFT, 37}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, REDUCE, 46}, },
			{{-1, REDUCE, 42}, },
			{{-1, ERROR, 101}, {30, SHIFT, 119}, },
			{{-1, ERROR, 102}, {47, SHIFT, 120}, },
			{{-1, REDUCE, 56}, {29, SHIFT, 121}, },
			{{-1, ERROR, 104}, {47, SHIFT, 124}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 109}, {3, SHIFT, 125}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 112}, {51, SHIFT, 8}, },
			{{-1, ERROR, 113}, {51, SHIFT, 127}, },
			{{-1, REDUCE, 26}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 116}, {51, SHIFT, 128}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 51}, },
			{{-1, ERROR, 119}, {9, SHIFT, 37}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 121}, {51, SHIFT, 101}, },
			{{-1, REDUCE, 59}, },
			{{-1, REDUCE, 57}, {29, SHIFT, 121}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 125}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 126}, {28, SHIFT, 135}, },
			{{-1, ERROR, 127}, {28, SHIFT, 136}, },
			{{-1, ERROR, 128}, {27, SHIFT, 137}, },
			{{-1, ERROR, 129}, {45, SHIFT, 138}, },
			{{-1, REDUCE, 29}, {41, SHIFT, 139}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 58}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 135}, {30, SHIFT, 142}, },
			{{-1, ERROR, 136}, {32, SHIFT, 143}, },
			{{-1, ERROR, 137}, {51, SHIFT, 144}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 139}, {51, SHIFT, 128}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 30}, {41, SHIFT, 139}, },
			{{-1, ERROR, 142}, {9, SHIFT, 37}, {14, SHIFT, 38}, {15, SHIFT, 39}, {16, SHIFT, 40}, {17, SHIFT, 41}, {18, SHIFT, 42}, {19, SHIFT, 43}, {27, SHIFT, 44}, {33, SHIFT, 45}, {42, SHIFT, 46}, {43, SHIFT, 47}, {51, SHIFT, 48}, },
			{{-1, ERROR, 143}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 144}, {28, SHIFT, 149}, },
			{{-1, REDUCE, 34}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 147}, {32, SHIFT, 150}, },
			{{-1, REDUCE, 27}, },
			{{-1, ERROR, 149}, {8, SHIFT, 151}, },
			{{-1, ERROR, 150}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, ERROR, 151}, {0, SHIFT, 14}, {1, SHIFT, 15}, {4, SHIFT, 16}, {5, SHIFT, 17}, {6, SHIFT, 18}, {7, SHIFT, 19}, {12, SHIFT, 20}, {24, SHIFT, 21}, {25, SHIFT, 22}, {26, SHIFT, 23}, {27, SHIFT, 24}, {35, SHIFT, 25}, {36, SHIFT, 26}, {37, SHIFT, 27}, {38, SHIFT, 28}, {39, SHIFT, 29}, {51, SHIFT, 30}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 33}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 2}, },
			{{-1, 31}, {15, 54}, {24, 64}, {35, 72}, {52, 83}, {84, 108}, {85, 109}, {86, 110}, {87, 111}, {90, 114}, {91, 115}, {125, 134}, {143, 148}, {150, 152}, {151, 153}, },
			{{-1, 32}, {21, 61}, {22, 62}, {23, 63}, {25, 65}, {26, 66}, {27, 67}, {29, 69}, {32, 70}, {62, 92}, {65, 94}, {68, 95}, },
			{{-1, 60}, },
			{{-1, 129}, },
			{{-1, 130}, {139, 145}, },
			{{-1, 140}, {141, 146}, },
			{{-1, 33}, },
			{{-1, 49}, {34, 71}, {44, 76}, {45, 77}, {142, 147}, },
			{{-1, 50}, {42, 74}, {43, 75}, {80, 105}, {81, 106}, {82, 107}, },
			{{-1, 51}, {97, 117}, {98, 118}, {119, 131}, },
			{{-1, 5}, {6, 13}, },
			{{-1, 9}, {10, 36}, {18, 55}, {19, 56}, {53, 36}, {112, 126}, },
			{{-1, 102}, {79, 104}, },
			{{-1, 122}, {123, 133}, },
			{{-1, 103}, {121, 132}, },
			{{-1, 6}, },
			{{-1, 10}, {12, 53}, },
			{{-1, 141}, },
			{{-1, 123}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'types'",
			"expecting: 'environment', id",
			"expecting: EOF",
			"expecting: 'body', id",
			"expecting: '='",
			"expecting: int, 'if', 'true', 'false', 'fn', 'lfn', 'let', 'close', 'send', 'receive', '(', 'fork', 'accept', 'request', 'select', 'case', id",
			"expecting: ':'",
			"expecting: '~', 'int', 'bool', 'unit', 'end', '!', '?', '(', '[', '&', '+', id",
			"expecting: int, 'then', 'else', 'true', 'false', 'in', '(', ')', 'of', '|', '}', id, EOF",
			"expecting: id",
			"expecting: 'fun', '(', id",
			"expecting: int, 'true', 'false', '(', id",
			"expecting: int, 'then', 'else', 'true', 'false', 'in', '(', ')', '|', '}', id, EOF",
			"expecting: '=>', '.', '->', '-o', '#', ')', '=', ']', 'environment', 'body', id",
			"expecting: '=>', ')', ',', '=', ']', '>', 'environment', 'body', id",
			"expecting: 'int', 'bool', 'unit', '('",
			"expecting: '<'",
			"expecting: '=>', '->', '-o', '#', ')', '=', ']', 'environment', 'body', id",
			"expecting: '=>', ')', '=', ']', 'environment', 'body', id",
			"expecting: 'then'",
			"expecting: '=>'",
			"expecting: 'in'",
			"expecting: 'then', 'else', 'in', ')', '|', '}', EOF",
			"expecting: ')'",
			"expecting: 'of'",
			"expecting: '=>', ')', 'body', id",
			"expecting: '.'",
			"expecting: ']'",
			"expecting: '('",
			"expecting: ','",
			"expecting: '{'",
			"expecting: '~', 'end', '!', '?', '&', '+', id",
			"expecting: '>'",
			"expecting: ',', '>'",
			"expecting: 'else'",
			"expecting: '}'",
			"expecting: '|', '}'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 4, 1, 1, 5, 6, 3, 3, 7, 3, 1, 8, 5, 8, 8, 9, 9, 10, 11, 11, 11, 5, 11, 11, 11, 9, 11, 8, 2, 12, 8, 7, 5, 3, 9, 13, 13, 13, 14, 15, 15, 7, 7, 16, 16, 14, 1, 17, 18, 5, 3, 19, 20, 20, 9, 9, 4, 21, 22, 11, 22, 23, 11, 22, 22, 11, 24, 22, 25, 2, 14, 26, 26, 23, 27, 9, 9, 15, 15, 15, 2, 5, 5, 5, 5, 28, 29, 5, 5, 22, 8, 22, 22, 30, 31, 31, 13, 18, 6, 32, 33, 32, 18, 18, 18, 2, 34, 22, 22, 9, 9, 21, 22, 9, 14, 14, 31, 14, 9, 33, 33, 14, 5, 23, 23, 28, 35, 36, 33, 33, 33, 22, 6, 4, 9, 22, 9, 36, 36, 7, 5, 23, 36, 36, 4, 21, 20, 5, 5, 21, 36, 
        };*/
}
