/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : TypeEnv.java                                             */
/* DESCRIPTION   : Environment of type definitions                          */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/****************************************************************************/

package fls.typenv;

import java.util.*;

/* A type environment is simply a hash table, associating types with 
   type names. */

public class TypeEnv {

    Hashtable<String,TypeEnvEntry> env;

    public TypeEnv() {
	env = new Hashtable<String,TypeEnvEntry>();
    }

    public TypeEnvEntry put(String n, TypeEnvEntry e) {
	return env.put(n,e);
    }

    public TypeEnvEntry get(String n) {
	return env.get(n);
    }

}
