/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : InputType.java                                           */
/* DESCRIPTION   : Representation of input session type                     */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/****************************************************************************/

package fls.types;

public class InputType extends Type {
    public Type data;
    public Type cont;

    public InputType(Type d, Type c) {
	data = d;
	cont = c;
    }

    public boolean unlimited() {
	return false;
    }

    public boolean base() {
	return false;
    }

    public Type getData() {
	return data;
    }

    public Type getCont() {
	return cont;
    }

    public String name() {
	String n = "";
	if (!(data.base())) {
	    n = n + "?(" + data.name() + ")";
	}
	else {
	    n = n + "?" + data.name();
	};
	n = n + "." + cont.name();
	return n;
    }

    public boolean equal(Type t) {
	return ((t instanceof InputType)
		&& data.equal(((InputType)t).getData())
		&& cont.equal(((InputType)t).getCont()));
    }

    public Type dual() {
	return new OutputType(data,cont.dual());
    }

}
