/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : LinFunType.java                                          */
/* DESCRIPTION   : Representation of linear function type                   */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/****************************************************************************/

package fls.types;

public class LinFunType extends Type {
    public Type arg;
    public Type res;

    public LinFunType(Type a, Type r) {
	arg = a;
	res = r;
    }

    public boolean unlimited() {
	return false;
    }

    public boolean base() {
	return false;
    }

    public Type getArg() {
	return arg;
    }

    public Type getRes() {
	return res;
    }

    public String name() {
	String n = "";
	if (!(arg.base())) {
	    n = n + "(" + arg.name() + ")";
	}
	else {
	    n = n + arg.name();
	};
	n = n + "-o";
	if (!(res.base())) {
	    n = n + "(" + res.name() + ")";
	}
	else {
	    n = n + res.name();
	};
	return n;
    }

    public boolean equal(Type t) {
	return ((t instanceof FunType)
		&& arg.equal(((FunType)t).getArg())
		&& res.equal(((FunType)t).getRes()));
    }

}
