/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : PortType.java                                            */
/* DESCRIPTION   : Representation of port type                              */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.types;

public class PortType extends Type {
    public Type ty;

    public PortType(Type t) {
	ty = t;
    }

    public boolean unlimited() {
	return true;
    }

    public boolean base() {
	return false;
    }

    public Type getTy() {
	return ty;
    }

    public String name() {
	String n = "[" + ty.name() + "]";
	return n;
    }

    public boolean equal(Type t) {
	return ((t instanceof PortType)
		&& ty.equal(((PortType)t).getTy()));
    }

}
