/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : TensorType.java                                          */
/* DESCRIPTION   : Representation of tensor type                            */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/****************************************************************************/

package fls.types;

public class TensorType extends Type {
    public Type left;
    public Type right;

    public TensorType(Type l, Type r) {
	left = l;
	right = r;
    }

    public boolean unlimited() {
	return false;
    }

    public boolean base() {
	return false;
    }

    public Type getLeft() {
	return left;
    }

    public Type getRight() {
	return right;
    }

    public String name() {
	String n = "";
	if (!(left.base())) {
	    n = n + "(" + left.name() + ")";
	}
	else {
	    n = n + left.name();
	};
	n = n + "#";
	if (!(right.base())) {
	    n = n + "(" + right.name() + ")";
	}
	else {
	    n = n + right.name();
	};
	return n;
    }

    public boolean equal(Type t) {
	return ((t instanceof TensorType)
		&& left.equal(((TensorType)t).getLeft())
		&& right.equal(((TensorType)t).getRight()));
    }

}
