/****************************************************************************/
/*                                                                          */
/*                   Copyright 2006 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : Type.java                                                */
/* DESCRIPTION   : Abstract class of types                                  */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 21st December 2005                                       */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 22nd December 2005                                       */
/****************************************************************************/

package fls.types;

import fls.typenv.*;
import fls.error.*;

public abstract class Type {

    public abstract String name();

    public abstract boolean unlimited();

    public abstract boolean base();

    public abstract boolean equal(Type t);

    public Type unfold(TypeEnv env) {
	return this;
    }

    public Type dual() {
	return this;
    }

}
